(function ($) {
    'use strict';

    if ($.fn.wpColorPicker) {
        $('input.rtwpvs-color-picker').wpColorPicker();
    }
    $(document.body).on('woocommerce_added_attribute', function () {
        if ($.fn.wpColorPicker) {
            $('input.rtwpvs-color-picker').wpColorPicker();
        }
        $('button.rtwpvs_remove_image_button').trigger('click');
    });

    $(document).on('click', 'button.rtwpvs_upload_image_button', function () {
        var _this = this;

        event.stopPropagation();

        var file_frame = void 0;

        if (typeof wp !== 'undefined' && wp.media && wp.media.editor) {

            // If the media frame already exists, reopen it.
            if (file_frame) {
                file_frame.open();
                return;
            }

            // Create the media frame.
            file_frame = wp.media.frames.select_image = wp.media({
                title: RTWPVSObj.media_title,
                button: {
                    text: RTWPVSObj.button_title
                },
                multiple: false
            });

            // When an image is selected, run a callback.
            file_frame.on('select', function () {
                var attachment = file_frame.state().get('selection').first().toJSON(),
                    self = $(this);
                if ($.trim(attachment.id) !== '') {
                    var url = typeof attachment.sizes.thumbnail === 'undefined' ? attachment.sizes.full.url : attachment.sizes.thumbnail.url;
                    self.prev().val(attachment.id);
                    self.closest('.meta-image-field-wrapper').find('img').attr('src', url);
                    self.next().show();
                }
            });

            // When open select selected
            file_frame.on('open', function () {
                // Grab our attachment selection and construct a JSON representation of the model.
                var selection = file_frame.state().get('selection');
                var current = $(_this).prev().val();
                var attachment = wp.media.attachment(current);
                attachment.fetch();
                selection.add(attachment ? [attachment] : []);
            });

            // Finally, open the modal.
            file_frame.open();
        }
    });

    $(document).on('click', 'button.rtwpvs_remove_image_button', function () {
        event.preventDefault();
        event.stopPropagation();

        var self = $(this),
            placeholder = self.closest('.meta-image-field-wrapper').find('img').data('placeholder');
        self.closest('.meta-image-field-wrapper').find('img').attr('src', placeholder);
        self.prev().prev().val('');
        self.hide();
        return false;
    });

    // admin settings
    $('#rtwpvs-settings-wrapper').on('click', '.nav-tab', function (event) {
        event.preventDefault();
        var target = $(this).data('target');
        $(this).addClass('nav-tab-active').siblings().removeClass('nav-tab-active');
        $('#' + target).show().siblings().hide();
        $('#_last_active_tab').val(target);
        if (history.pushState) {
            var newurl = setGetParameter('section', target);
            window.history.pushState({ path: newurl }, '', newurl);
        }
    });

    function setGetParameter(paramName, paramValue) {
        var url = window.location.href;
        var hash = location.hash;
        url = url.replace(hash, '');
        if (url.indexOf("?") >= 0) {
            var params = url.substring(url.indexOf("?") + 1).split("&");
            var paramFound = false;
            params.forEach(function (param, index) {
                var p = param.split("=");
                if (p[0] == paramName) {
                    params[index] = paramName + "=" + paramValue;
                    paramFound = true;
                }
            });
            if (!paramFound) params.push(paramName + "=" + paramValue);
            url = url.substring(0, url.indexOf("?") + 1) + params.join("&");
        } else url += "?" + paramName + "=" + paramValue;
        return url + hash;
    }
})(jQuery);
